## com.fasterxml.jackson.databind.deser.std
Class EnumDeserializer

    java.lang.Object
      com.fasterxml.jackson.databind.JsonDeserializer<T>
          com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
              com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer<Enum<?>>
                  com.fasterxml.jackson.databind.deser.std.EnumDeserializer

    public class EnumDeserializer

extends StdScalarDeserializer<Enum<?>>

Deserializer class that can deserialize instances of specified Enum class from Strings and Integers.

Nested Class Summary
`protected static class` `EnumDeserializer.FactoryBasedDeserializer` Deserializer that uses a single-String static factory method for locating Enum values by String id.

Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer
`JsonDeserializer.None`

Field Summary
`protected EnumResolver<?>` `_resolver`

Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer
`_valueClass`

Constructor Summary
`EnumDeserializer(EnumResolver<?> res)`

Method Summary
`Enum<?>` `deserialize(JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`static JsonDeserializer<?>` `deserializerForCreator(DeserializationConfig config, Class<?> enumClass, AnnotatedMethod factory)` Factory method used when Enum instances are to be deserialized using a creator (static factory method)
`boolean` `isCachable()` Because of costs associated with constructing Enum resolvers, let's cache instances by default.

Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer
`deserializeWithType`

Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer
`_parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, findDeserializer, getValueClass, getValueType, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer
`deserialize, getEmptyValue, getKnownPropertyNames, getNullValue, getObjectIdReader, unwrappingDeserializer`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### _resolver

    protected final EnumResolver<?> _resolver

Constructor Detail

### EnumDeserializer

    public EnumDeserializer(EnumResolver<?> res)

Method Detail

### deserializerForCreator

    public static JsonDeserializer<?> deserializerForCreator(DeserializationConfig config,
                                                             Class<?> enumClass,
                                                             AnnotatedMethod factory)

  Factory method used when Enum instances are to be deserialized using a creator (static factory method)

  Returns:
    Deserializer based on given factory method, if type was suitable; null if type can not be used

### isCachable

    public boolean isCachable()

  Because of costs associated with constructing Enum resolvers, let's cache instances by default.

  Overrides:
    `isCachable` in class `JsonDeserializer<Enum<?>>`

### deserialize

    public Enum<?> deserialize(JsonParser jp,
                               DeserializationContext ctxt)
                        throws IOException,
                               JsonProcessingException

  Description copied from class: `JsonDeserializer`
  Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

  Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

  Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

  Specified by:
    `deserialize` in class `JsonDeserializer<Enum<?>>`
  Parameters:
    `jp` - Parsed used for reading JSON content
    `ctxt` - Context that can be used to access information about this deserialization activity.
  Returns:
    Deserializer value
  Throws:
    `IOException`
    `JsonProcessingException`

Copyright © 2012 fasterxml.com. All Rights Reserved.